<?php

	header('Content-Type: text/html; charset=utf-8');
	require_once ('../../../wp-config.php');
	
	$choices = get_option('kau-boys_autocompleter_choices');
	$framework = get_option('kau-boys_autocompleter_framework');
	$encoding = get_option('kau-boys_autocompleter_encoding');
	$searchfields = get_option('kau-boys_autocompleter_searchfields');
	$resultfields = get_option('kau-boys_autocompleter_resultfields');
	$titlelength = get_option('kau-boys_autocompleter_titlelength');
	$contentlength = get_option('kau-boys_autocompleter_contentlength');
	if(empty($choices)) $choices = 10;
	if(empty($framework)) $framework = 'jQuery';
	if(empty($encoding)) $encoding = 'UTF-8';
	if(empty($searchfields)) $searchfields = 'both';
	if(empty($resultfields)) $resultfields = 'both';
	if(empty($titlelength)) $titlelength = 50;
	if(empty($contentlength)) $contentlength = 120;
	
	mb_internal_encoding($encoding);
	
	$words = '%'.$_REQUEST['q'].'%';
	
	switch($searchfields){
		case 'post_title' : 
			$where = 'post_title LIKE "'.$words.'"';
			break;
		case 'post_content' : 
			$where = 'post_content LIKE "'.$words.'"';
		default :
			$where = 'post_title LIKE "'.$words.'" OR post_content LIKE "'.$words.'"';
	}
	
	$wp_query = new WP_Query();
	$wp_query->query(array(
		's' => $_REQUEST['q'],
		'showposts' => $choices,
		'post_status' => 'publish'
	));
	$posts = $wp_query->posts;

	$results = array();
	foreach ($posts as $key => $post){
		setup_postdata($post);
		$title = strip_tags(get_the_title());
		$content = strip_tags(strip_shortcodes(get_the_content()));
		if(mb_strpos(mb_strtolower(($searchfields == 'post_title')? $title : (($searchfields == 'post_content')? $content : $title.$content), $encoding), mb_strtolower($_REQUEST['q'], $encoding)) !== false){
			$results[] = array(
				'url' => get_permalink(),
				'title' => highlightSearchString(strtruncate($title, $titlelength, true), $_REQUEST['q']),
				'content' => (($resultfields == 'both')? highlightSearchString(strtruncate($content, $contentlength, false, '[...]', $_REQUEST['q']), $_REQUEST['q']) : '')
			);
		}
	}
	printResults($results, $framework);
			
	
	function highlightSearchString($value, $searchString){
		global $encoding;
		
		mb_regex_encoding($encoding);
		mb_internal_encoding($encoding);
		
		if((version_compare(phpversion(), '5.0') < 0) && (strtolower($encoding) == 'utf-8')){
			$value = utf8_encode(html_entity_decode(utf8_decode($value)));
		}
		
		$regex_chars = '\.+?(){}[]^$';
		for ($i=0; $i<mb_strlen($regex_chars); $i++) {
			$char = mb_substr($regex_chars, $i, 1);
			$searchString = str_replace($char, '\\'.$char, $searchString);
		}
		$searchString = '(.*)('.$searchString.')(.*)';
		return mb_eregi_replace($searchString, '\1<span class="ac_match">\2</span>\3', $value);
	}
	
	function strtruncate($str, $length = 50, $cutWord = false, $suffix = '...', $needle = ''){
		global $encoding;
		
		mb_internal_encoding($encoding);
		
		$str = trim($str);
		if((version_compare(phpversion(), '5.0') < 0) && (strtolower($encoding) == 'utf-8')){
			$str = utf8_encode(html_entity_decode(utf8_decode($str)));
		}else{
			$str = html_entity_decode($str, ENT_NOQUOTES, $encoding);
		}
		
		
		if(mb_strlen($str)>$length){
			if(!empty($needle) && mb_strpos(mb_strtolower($str, $encoding), mb_strtolower($needle, $encoding)) > 0){
				$pos = mb_strpos(mb_strtolower($str, $encoding), mb_strtolower($needle, $encoding)) + (mb_strlen($needle) / 2);
				$start = $pos - ($length / 2) - mb_strlen($suffix);
				$string = mb_substr($str, (($start > 0)? $start : 0), ($pos + ($length / 2) + mb_strlen($suffix) + (mb_strlen($needle) /2) - (($start > 0)? $start : 0)));
				if($cutWord){
					return $suffix.$string.$suffix;
				} else {
					$firstWhitespace = mb_strpos($string, ' ');
					$lastWhitespace = mb_strrpos($string, ' ');
					return $suffix.' '.(!empty($lastWhitespace)? mb_substr($string, $firstWhitespace, ($lastWhitespace - $firstWhitespace)) : $string).' '.$suffix;
				}
			} else {
				$string = mb_substr($str, 0, $length - mb_strlen($suffix));
				return (($cutWord) ? $string : mb_substr($string, 0, mb_strrpos($string, ' ')).' ').$suffix;
			}
		} else {
			return $str;	
		}
	}
	
	function printResults($results, $framework){
		if($framework == 'scriptaculous'){
			echo '<ul>';
			foreach($results as $result){
				echo '	<li>
							<a href="'.$result['url'].'"></a>
							<span class="title">'.$result['title'].'</span>
							<p>'.$result['content'].'</p>
						</li>';
			}
			echo '</ul>';	
		} else {	
			foreach($results as $result){
				echo str_replace(array("\n", "\r", '|'), array(' ',' ', '&#124;'), '<span class="title">'.$result['title'].'</span><p>'.$result['content'].'</p>')
					.'|'
					.str_replace(array("\n", "\r", '|'), array(' ',' ', '&#124;'), $result['url'])
					."\n";
			}
		}
	}
	
?>